#Copyright 2006 DR0ID <dr0id@bluewin.ch> http://mypage.bluewin.ch/DR0ID
#
#
#
"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__= "$Revision: 7 $"
__date__   = "$Date: 2006-09-02 22:51:00 +0200 (Sa, 02 Sep 2006) $"



import pygame

import math



class NeedleGroup:
    
    def __init__(self, image, size):
        self.needlePos = [] #[[x1,y1],[],[]]
        self.angles = [] #[angle1, ...]
        self.rects = []

        self.stock = []
        
        for a in range(360):
            self.stock.append(pygame.transform.rotozoom(image, a, size))
        
    def add(self, pos):
        self.angles.append(0)
        self.needlePos.append(pos)
        
    def update(self):
        mpos = pygame.mouse.get_pos()
        diff = map(lambda p: (p[1]-mpos[1], -p[0]+mpos[0]), self.needlePos) 
        
        self.angles = map(lambda x:int(math.degrees(math.atan2(*x))), diff)
        self.rects  = map(lambda i,p:self.stock[i].get_rect(center=p), self.angles, self.needlePos)
        
    def draw(self, scr):
        map(lambda i,p:scr.blit(self.stock[i], p), self.angles, self.rects)
            
        

def main():
    pygame.display.init()
    scr = pygame.display.set_mode((800,600))
    bgd = pygame.Surface(scr.get_size()).convert()
    bgd.fill((0,0,0))
    scr.blit(bgd, (0,0))
    
    # init stuff
    needleImg = pygame.image.load("needle.png")
    #needleImg.set_colorkey()
    
    needleImg.set_colorkey((255,255,255,255))
    
    needles = NeedleGroup(needleImg, 0.15)
    
    count = 0
    gridstep = 25
    for y in range(gridstep, 600, gridstep):
        for x in range(gridstep, 800, gridstep):
            needles.add( (x,y) )
            count += 1
            
    print "needles count: ", count
    
    looping = True
    clock = pygame.time.Clock()
    tick = clock.tick
    needles.update()
    needles.draw(scr)
    pygame.display.flip()
    scr.blit(bgd,(0,0))
    scr_flip = pygame.display.flip
    set_caption = pygame.display.set_caption
    while looping:
        for event in pygame.event.get():
##            event = pygame.event.wait()
            if event.type == pygame.QUIT:
               looping = False
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    looping = False 
            elif event.type == pygame.MOUSEMOTION:
                pass
        needles.update()
        needles.draw(scr)
        scr_flip()
        scr.blit(bgd, (0,0))
        
        # without these two line it would run faster
        tick()
        set_caption("fps: "+str( clock.get_fps())+" arrows count:"+str(count))
                            
    # loop end
    pygame.quit()
                    
if __name__== '__main__':
    main()